Index: plugins/blowupConfig/index.php
===================================================================
--- plugins/blowupConfig/index.php	(revision 1179)
+++ plugins/blowupConfig/index.php	(revision 1588)
@@ -15,4 +15,5 @@
 
 $can_write_images = blowupConfig::canWriteImages();
+$can_write_css = blowupConfig::canWriteCss();
 
 if ($core->error->flag()) {
@@ -188,4 +189,9 @@
 			$blowup_user['prelude_c'] = blowupConfig::adjustColor($_POST['prelude_c']);
 			blowupConfig::createImages($blowup_user,$uploaded);
+		}
+
+		if ($can_write_css)
+		{
+			blowupConfig::createCss($blowup_user);
 		}
 
@@ -221,8 +227,13 @@
 <body>
 <?php
-echo
-'<h2>'.html::escapeHTML($core->blog->name).
-' &rsaquo; <a href="blog_theme.php">'.__('Blog appearance').'</a> &rsaquo; <span class="page-title">'.__('Blowup configuration').'</span></h2>'.
-'<p><a class="back" href="blog_theme.php">'.__('back').'</a></p>';
+echo dcPage::breadcrumb(
+	array(
+		html::escapeHTML($core->blog->name) => '',
+		__('Blog appearance') => 'blog_theme.php',
+		'<span class="page-title">'.__('Blowup configuration').'</span>' => ''
+	));
+
+echo
+'<p><a class="back" href="blog_theme.php">'.__('Back to Blog appearance').'</a></p>';
 
 
@@ -233,51 +244,50 @@
 
 if (!empty($_GET['upd'])) {
-	dcPage::message(__('Theme configuration has been successfully updated.'));
+	dcPage::success(__('Theme configuration has been successfully updated.'));
 }
 
 echo '<form id="theme_config" action="'.$p_url.'" method="post" enctype="multipart/form-data">';
 
-echo '<fieldset><legend>'.__('General').'</legend>';
+echo '<div class="fieldset"><h3>'.__('Customization').'</h3>'.
+'<h4>'.__('General').'</h4>';
 
 if ($can_write_images) {
 	echo
-	'<p class="field"><label for="body_bg_c">'.__('Background color:').' '.
-	form::field('body_bg_c',7,7,$blowup_user['body_bg_c'],'colorpicker').'</label></p>'.
-
-	'<p class="field"><label for="body_bg_g">'.__('Background color fill:').' '.
-	form::combo('body_bg_g',$gradient_types,$blowup_user['body_bg_g']).'</label></p>';
-}
-
-echo
-'<p class="field"><label for="body_txt_f">'.__('Main text font:').' '.
-form::combo('body_txt_f',blowupConfig::fontsList(),$blowup_user['body_txt_f']).'</label></p>'.
-
-'<p class="field"><label for="body_txt_s">'.__('Main text font size:').' '.
-form::field('body_txt_s',7,7,$blowup_user['body_txt_s']).'</label></p>'.
-
-'<p class="field"><label for="body_txt_c">'.__('Main text color:').' '.
-form::field('body_txt_c',7,7,$blowup_user['body_txt_c'],'colorpicker').'</label></p>'.
-
-'<p class="field"><label for="body_line_height">'.__('Text line height:').' '.
-form::field('body_line_height',7,7,$blowup_user['body_line_height']).'</label></p>'.
-'</fieldset>'.
-
-'<fieldset><legend>'.__('Links').'</legend>'.
-'<p class="field"><label for="body_link_c">'.__('Links color:').' '.
-form::field('body_link_c',7,7,$blowup_user['body_link_c'],'colorpicker').'</label></p>'.
-
-'<p class="field"><label for="body_link_v_c">'.__('Visited links color:').' '.
-form::field('body_link_v_c',7,7,$blowup_user['body_link_v_c'],'colorpicker').'</label></p>'.
-
-'<p class="field"><label for="body_link_f_c">'.__('Focus links color:').' '.
-form::field('body_link_f_c',7,7,$blowup_user['body_link_f_c'],'colorpicker').'</label></p>'.
-'</fieldset>'.
-
-'<fieldset><legend>'.__('Page top').'</legend>';
+	'<p class="field"><label for="body_bg_c">'.__('Background color:').'</label> '.
+	form::field('body_bg_c',7,7,$blowup_user['body_bg_c'],'colorpicker').'</p>'.
+
+	'<p class="field"><label for="body_bg_g">'.__('Background color fill:').'</label> '.
+	form::combo('body_bg_g',$gradient_types,$blowup_user['body_bg_g']).'</p>';
+}
+
+echo
+'<p class="field"><label for="body_txt_f">'.__('Main text font:').'</label> '.
+form::combo('body_txt_f',blowupConfig::fontsList(),$blowup_user['body_txt_f']).'</p>'.
+
+'<p class="field"><label for="body_txt_s">'.__('Main text font size:').'</label> '.
+form::field('body_txt_s',7,7,$blowup_user['body_txt_s']).'</p>'.
+
+'<p class="field"><label for="body_txt_c">'.__('Main text color:').'</label> '.
+form::field('body_txt_c',7,7,$blowup_user['body_txt_c'],'colorpicker').'</p>'.
+
+'<p class="field"><label for="body_line_height">'.__('Text line height:').'</label> '.
+form::field('body_line_height',7,7,$blowup_user['body_line_height']).'</p>'.
+
+'<h4 class="border-top">'.__('Links').'</h4>'.
+'<p class="field"><label for="body_link_c">'.__('Links color:').'</label> '.
+form::field('body_link_c',7,7,$blowup_user['body_link_c'],'colorpicker').'</p>'.
+
+'<p class="field"><label for="body_link_v_c">'.__('Visited links color:').'</label> '.
+form::field('body_link_v_c',7,7,$blowup_user['body_link_v_c'],'colorpicker').'</p>'.
+
+'<p class="field"><label for="body_link_f_c">'.__('Focus links color:').'</label> '.
+form::field('body_link_f_c',7,7,$blowup_user['body_link_f_c'],'colorpicker').'</p>'.
+
+'<h4 class="border-top">'.__('Page top').'</h4>';
 
 if ($can_write_images) {
 	echo
-	'<p class="field"><label for="prelude_c">'.__('Prelude color:').' '.
-	form::field('prelude_c',7,7,$blowup_user['prelude_c'],'colorpicker').'</label></p>';
+	'<p class="field"><label for="prelude_c">'.__('Prelude color:').'</label> '.
+	form::field('prelude_c',7,7,$blowup_user['prelude_c'],'colorpicker').'</p>';
 }
 
@@ -286,19 +296,18 @@
 form::checkbox('blog_title_hide',1,$blowup_user['blog_title_hide']).'</label></p>'.
 
-'<p class="field"><label for="blog_title_f">'.__('Main title font:').' '.
-form::combo('blog_title_f',blowupConfig::fontsList(),$blowup_user['blog_title_f']).'</label></p>'.
-
-'<p class="field"><label for="blog_title_s">'.__('Main title font size:').' '.
-form::field('blog_title_s',7,7,$blowup_user['blog_title_s']).'</label></p>'.
-
-'<p class="field"><label for="blog_title_c">'.__('Main title color:').' '.
-form::field('blog_title_c',7,7,$blowup_user['blog_title_c'],'colorpicker').'</label></p>'.
-
-'<p class="field"><label for="blog_title_a">'.__('Main title alignment:').' '.
-form::combo('blog_title_a',array(__('center')=>'center',__('left')=>'left',__('right')=>'right'),$blowup_user['blog_title_a']).'</label></p>'.
-
-'<p class="field"><label for="blog_title_p">'.__('Main title position (x:y)').' '.
-form::field('blog_title_p',7,7,$blowup_user['blog_title_p']).'</label></p>'.
-'</fieldset>';
+'<p class="field"><label for="blog_title_f">'.__('Main title font:').'</label> '.
+form::combo('blog_title_f',blowupConfig::fontsList(),$blowup_user['blog_title_f']).'</p>'.
+
+'<p class="field"><label for="blog_title_s">'.__('Main title font size:').'</label> '.
+form::field('blog_title_s',7,7,$blowup_user['blog_title_s']).'</p>'.
+
+'<p class="field"><label for="blog_title_c">'.__('Main title color:').'</label> '.
+form::field('blog_title_c',7,7,$blowup_user['blog_title_c'],'colorpicker').'</p>'.
+
+'<p class="field"><label for="blog_title_a">'.__('Main title alignment:').'</label> '.
+form::combo('blog_title_a',array(__('center')=>'center',__('left')=>'left',__('right')=>'right'),$blowup_user['blog_title_a']).'</p>'.
+
+'<p class="field"><label for="blog_title_p">'.__('Main title position (x:y)').'</label> '.
+form::field('blog_title_p',7,7,$blowup_user['blog_title_p']).'</p>';
 
 if ($can_write_images) {
@@ -310,129 +319,125 @@
 
 	echo
-	'<fieldset><legend>'.__('Top image').'</legend>'.
-	'<p class="field"><label for="top_image">'.__('Top image').
-	form::combo('top_image',$top_images,($blowup_user['top_image'] ? $blowup_user['top_image'] : 'default')).'</label></p>'.
+	'<h4 class="border-top">'.__('Top image').'</h4>'.
+	'<p class="field"><label for="top_image">'.__('Top image').'</label> '.
+	form::combo('top_image',$top_images,($blowup_user['top_image'] ? $blowup_user['top_image'] : 'default')).'</p>'.
 	'<p>'.__('Choose "Custom..." to upload your own image.').'</p>'.
 
-	'<p id="uploader"><label for="upfile">'.__('Add your image:').
+	'<p id="uploader"><label for="upfile">'.__('Add your image:').'</label> '.
 	' ('.sprintf(__('JPEG or PNG file, 800 pixels wide, maximum size %s'),files::size(DC_MAX_UPLOAD_SIZE)).')'.
 	'<input type="file" name="upfile" id="upfile" size="35" />'.
-	'</label></p>'.
-
-	'<h3>'.__('Preview').'</h3>'.
+	'</p>'.
+
+	'<h5>'.__('Preview').'</h5>'.
 	'<div class="grid" style="width:800px;border:1px solid #ccc;">'.
 	'<img style="display:block;" src="'.$preview_image.'" alt="" id="image-preview" />'.
-	'</div>'.
-	'</fieldset>';
-}
-
-echo
-'<fieldset><legend>'.__('Sidebar').'</legend>'.
-'<p class="field"><label for="sidebar_position">'.__('Sidebar position:').' '.
-form::combo('sidebar_position',array(__('right')=>'right',__('left')=>'left'),$blowup_user['sidebar_position']).'</label></p>'.
-
-'<p class="field"><label for="sidebar_text_f">'.__('Sidebar text font:').' '.
-form::combo('sidebar_text_f',blowupConfig::fontsList(),$blowup_user['sidebar_text_f']).'</label></p>'.
-
-'<p class="field"><label for="sidebar_text_s">'.__('Sidebar text font size:').' '.
-form::field('sidebar_text_s',7,7,$blowup_user['sidebar_text_s']).'</label></p>'.
-
-'<p class="field"><label for="sidebar_text_c">'.__('Sidebar text color:').' '.
-form::field('sidebar_text_c',7,7,$blowup_user['sidebar_text_c'],'colorpicker').'</label></p>'.
-
-'<p class="field"><label for="sidebar_title_f">'.__('Sidebar titles font:').' '.
-form::combo('sidebar_title_f',blowupConfig::fontsList(),$blowup_user['sidebar_title_f']).'</label></p>'.
-
-'<p class="field"><label for="sidebar_title_s">'.__('Sidebar titles font size:').' '.
-form::field('sidebar_title_s',7,7,$blowup_user['sidebar_title_s']).'</label></p>'.
-
-'<p class="field"><label for="sidebar_title_c">'.__('Sidebar titles color:').' '.
-form::field('sidebar_title_c',7,7,$blowup_user['sidebar_title_c'],'colorpicker').'</label></p>'.
-
-'<p class="field"><label for="sidebar_title2_f">'.__('Sidebar 2nd level titles font:').' '.
-form::combo('sidebar_title2_f',blowupConfig::fontsList(),$blowup_user['sidebar_title2_f']).'</label></p>'.
-
-'<p class="field"><label for="sidebar_title2_s">'.__('Sidebar 2nd level titles font size:').' '.
-form::field('sidebar_title2_s',7,7,$blowup_user['sidebar_title2_s']).'</label></p>'.
-
-'<p class="field"><label for="sidebar_title2_c">'.__('Sidebar 2nd level titles color:').' '.
-form::field('sidebar_title2_c',7,7,$blowup_user['sidebar_title2_c'],'colorpicker').'</label></p>'.
-
-'<p class="field"><label for="sidebar_line_c">'.__('Sidebar lines color:').' '.
-form::field('sidebar_line_c',7,7,$blowup_user['sidebar_line_c'],'colorpicker').'</label></p>'.
-
-'<p class="field"><label for="sidebar_link_c">'.__('Sidebar links color:').' '.
-form::field('sidebar_link_c',7,7,$blowup_user['sidebar_link_c'],'colorpicker').'</label></p>'.
-
-'<p class="field"><label for="sidebar_link_v_c">'.__('Sidebar visited links color:').' '.
-form::field('sidebar_link_v_c',7,7,$blowup_user['sidebar_link_v_c'],'colorpicker').'</label></p>'.
-
-'<p class="field"><label for="sidebar_link_f_c">'.__('Sidebar focus links color:').' '.
-form::field('sidebar_link_f_c',7,7,$blowup_user['sidebar_link_f_c'],'colorpicker').'</label></p>'.
-'</fieldset>'.
-
-'<fieldset><legend>'.__('Entries').'</legend>'.
-'<p class="field"><label for="date_title_f">'.__('Date title font:').' '.
-form::combo('date_title_f',blowupConfig::fontsList(),$blowup_user['date_title_f']).'</label></p>'.
-
-'<p class="field"><label for="date_title_s">'.__('Date title font size:').' '.
-form::field('date_title_s',7,7,$blowup_user['date_title_s']).'</label></p>'.
-
-'<p class="field"><label for="date_title_c">'.__('Date title color:').' '.
-form::field('date_title_c',7,7,$blowup_user['date_title_c'],'colorpicker').'</label></p>'.
-
-'<p class="field"><label for="post_title_f">'.__('Entry title font:').' '.
-form::combo('post_title_f',blowupConfig::fontsList(),$blowup_user['post_title_f']).'</label></p>'.
-
-'<p class="field"><label for="post_title_s">'.__('Entry title font size:').' '.
-form::field('post_title_s',7,7,$blowup_user['post_title_s']).'</label></p>'.
-
-'<p class="field"><label for="post_title_c">'.__('Entry title color:').' '.
-form::field('post_title_c',7,7,$blowup_user['post_title_c'],'colorpicker').'</label></p>';
+	'</div>';
+}
+
+echo
+'<h4 class="border-top">'.__('Sidebar').'</h4>'.
+'<p class="field"><label for="sidebar_position">'.__('Sidebar position:').'</label> '.
+form::combo('sidebar_position',array(__('right')=>'right',__('left')=>'left'),$blowup_user['sidebar_position']).'</p>'.
+
+'<p class="field"><label for="sidebar_text_f">'.__('Sidebar text font:').'</label> '.
+form::combo('sidebar_text_f',blowupConfig::fontsList(),$blowup_user['sidebar_text_f']).'</p>'.
+
+'<p class="field"><label for="sidebar_text_s">'.__('Sidebar text font size:').'</label> '.
+form::field('sidebar_text_s',7,7,$blowup_user['sidebar_text_s']).'</p>'.
+
+'<p class="field"><label for="sidebar_text_c">'.__('Sidebar text color:').'</label> '.
+form::field('sidebar_text_c',7,7,$blowup_user['sidebar_text_c'],'colorpicker').'</p>'.
+
+'<p class="field"><label for="sidebar_title_f">'.__('Sidebar titles font:').'</label> '.
+form::combo('sidebar_title_f',blowupConfig::fontsList(),$blowup_user['sidebar_title_f']).'</p>'.
+
+'<p class="field"><label for="sidebar_title_s">'.__('Sidebar titles font size:').'</label> '.
+form::field('sidebar_title_s',7,7,$blowup_user['sidebar_title_s']).'</p>'.
+
+'<p class="field"><label for="sidebar_title_c">'.__('Sidebar titles color:').'</label> '.
+form::field('sidebar_title_c',7,7,$blowup_user['sidebar_title_c'],'colorpicker').'</p>'.
+
+'<p class="field"><label for="sidebar_title2_f">'.__('Sidebar 2nd level titles font:').'</label> '.
+form::combo('sidebar_title2_f',blowupConfig::fontsList(),$blowup_user['sidebar_title2_f']).'</p>'.
+
+'<p class="field"><label for="sidebar_title2_s">'.__('Sidebar 2nd level titles font size:').'</label> '.
+form::field('sidebar_title2_s',7,7,$blowup_user['sidebar_title2_s']).'</p>'.
+
+'<p class="field"><label for="sidebar_title2_c">'.__('Sidebar 2nd level titles color:').'</label> '.
+form::field('sidebar_title2_c',7,7,$blowup_user['sidebar_title2_c'],'colorpicker').'</p>'.
+
+'<p class="field"><label for="sidebar_line_c">'.__('Sidebar lines color:').'</label> '.
+form::field('sidebar_line_c',7,7,$blowup_user['sidebar_line_c'],'colorpicker').'</p>'.
+
+'<p class="field"><label for="sidebar_link_c">'.__('Sidebar links color:').'</label> '.
+form::field('sidebar_link_c',7,7,$blowup_user['sidebar_link_c'],'colorpicker').'</p>'.
+
+'<p class="field"><label for="sidebar_link_v_c">'.__('Sidebar visited links color:').'</label> '.
+form::field('sidebar_link_v_c',7,7,$blowup_user['sidebar_link_v_c'],'colorpicker').'</p>'.
+
+'<p class="field"><label for="sidebar_link_f_c">'.__('Sidebar focus links color:').'</label> '.
+form::field('sidebar_link_f_c',7,7,$blowup_user['sidebar_link_f_c'],'colorpicker').'</p>'.
+
+'<h4 class="border-top">'.__('Entries').'</h4>'.
+'<p class="field"><label for="date_title_f">'.__('Date title font:').'</label> '.
+form::combo('date_title_f',blowupConfig::fontsList(),$blowup_user['date_title_f']).'</p>'.
+
+'<p class="field"><label for="date_title_s">'.__('Date title font size:').'</label> '.
+form::field('date_title_s',7,7,$blowup_user['date_title_s']).'</p>'.
+
+'<p class="field"><label for="date_title_c">'.__('Date title color:').'</label> '.
+form::field('date_title_c',7,7,$blowup_user['date_title_c'],'colorpicker').'</p>'.
+
+'<p class="field"><label for="post_title_f">'.__('Entry title font:').'</label> '.
+form::combo('post_title_f',blowupConfig::fontsList(),$blowup_user['post_title_f']).'</p>'.
+
+'<p class="field"><label for="post_title_s">'.__('Entry title font size:').'</label> '.
+form::field('post_title_s',7,7,$blowup_user['post_title_s']).'</p>'.
+
+'<p class="field"><label for="post_title_c">'.__('Entry title color:').'</label> '.
+form::field('post_title_c',7,7,$blowup_user['post_title_c'],'colorpicker').'</p>';
 
 if ($can_write_images) {
 	echo
-	'<p class="field"><label for="post_comment_bg_c">'.__('Comment background color:').' '.
-	form::field('post_comment_bg_c',7,7,$blowup_user['post_comment_bg_c'],'colorpicker').'</label></p>';
-}
-
-echo
-'<p class="field"><label for="post_comment_c">'.__('Comment text color:').' '.
-form::field('post_comment_c',7,7,$blowup_user['post_comment_c'],'colorpicker').'</label></p>';
+	'<p class="field"><label for="post_comment_bg_c">'.__('Comment background color:').'</label> '.
+	form::field('post_comment_bg_c',7,7,$blowup_user['post_comment_bg_c'],'colorpicker').'</p>';
+}
+
+echo
+'<p class="field"><label for="post_comment_c">'.__('Comment text color:').'</label> '.
+form::field('post_comment_c',7,7,$blowup_user['post_comment_c'],'colorpicker').'</p>';
 
 if ($can_write_images) {
 	echo
-	'<p class="field"><label for="post_commentmy_bg_c">'.__('My comment background color:').' '.
-	form::field('post_commentmy_bg_c',7,7,$blowup_user['post_commentmy_bg_c'],'colorpicker').'</label></p>';
-}
-
-echo
-'<p class="field"><label for="post_commentmy_c">'.__('My comment text color:').' '.
-form::field('post_commentmy_c',7,7,$blowup_user['post_commentmy_c'],'colorpicker').'</label></p>'.
-'</fieldset>'.
-
-'<fieldset><legend>'.__('Footer').'</legend>'.
-'<p class="field"><label for="footer_f">'.__('Footer font:').' '.
-form::combo('footer_f',blowupConfig::fontsList(),$blowup_user['footer_f']).'</label></p>'.
-
-'<p class="field"><label for="footer_s">'.__('Footer font size:').' '.
-form::field('footer_s',7,7,$blowup_user['footer_s']).'</label></p>'.
-
-'<p class="field"><label for="footer_c">'.__('Footer color:').' '.
-form::field('footer_c',7,7,$blowup_user['footer_c'],'colorpicker').'</label></p>'.
-
-'<p class="field"><label for="footer_l_c">'.__('Footer links color:').' '.
-form::field('footer_l_c',7,7,$blowup_user['footer_l_c'],'colorpicker').'</label></p>'.
-
-'<p class="field"><label for="footer_bg_c">'.__('Footer background color:').' '.
-form::field('footer_bg_c',7,7,$blowup_user['footer_bg_c'],'colorpicker').'</label></p>'.
-'</fieldset>';
-
-echo
-'<fieldset><legend>'.__('Additional CSS').'</legend>'.
-'<p><label for="extra_css">'.__('Any additional CSS styles (must be written using the CSS syntax):').' '.
+	'<p class="field"><label for="post_commentmy_bg_c">'.__('My comment background color:').'</label> '.
+	form::field('post_commentmy_bg_c',7,7,$blowup_user['post_commentmy_bg_c'],'colorpicker').'</p>';
+}
+
+echo
+'<p class="field"><label for="post_commentmy_c">'.__('My comment text color:').'</label> '.
+form::field('post_commentmy_c',7,7,$blowup_user['post_commentmy_c'],'colorpicker').'</p>'.
+
+'<h4 class="border-top">'.__('Footer').'</h4>'.
+'<p class="field"><label for="footer_f">'.__('Footer font:').'</label> '.
+form::combo('footer_f',blowupConfig::fontsList(),$blowup_user['footer_f']).'</p>'.
+
+'<p class="field"><label for="footer_s">'.__('Footer font size:').'</label> '.
+form::field('footer_s',7,7,$blowup_user['footer_s']).'</p>'.
+
+'<p class="field"><label for="footer_c">'.__('Footer color:').'</label> '.
+form::field('footer_c',7,7,$blowup_user['footer_c'],'colorpicker').'</p>'.
+
+'<p class="field"><label for="footer_l_c">'.__('Footer links color:').'</label> '.
+form::field('footer_l_c',7,7,$blowup_user['footer_l_c'],'colorpicker').'</p>'.
+
+'<p class="field"><label for="footer_bg_c">'.__('Footer background color:').'</label> '.
+form::field('footer_bg_c',7,7,$blowup_user['footer_bg_c'],'colorpicker').'</p>';
+
+echo
+'<h4 class="border-top">'.__('Additional CSS').'</h4>'.
+'<p><label for="extra_css">'.__('Any additional CSS styles (must be written using the CSS syntax):').'</label> '.
 form::textarea('extra_css',72,5,html::escapeHTML($blowup_user['extra_css']),'maximal','',false,'title="'.__('Additional CSS').'"').
-'</label></p>'.
-'</fieldset>';
+'</p>'.
+'</div>';
 
 
@@ -450,8 +455,11 @@
 }
 echo
-'<h3 id="bu_export">'.__('Configuration import / export').'</h3><fieldset>'.
+'<div class="fieldset">'.
+'<h3 id="bu_export">'.__('Configuration import / export').'</h3>'.
+'<div id="bu_export_content">'.
 '<p>'.__('You can share your configuration using the following code. To apply a configuration, paste the code, click on "Apply code" and save.').'</p>'.
 '<p>'.form::textarea('export_code',72,5,implode('; ',$tmp_array),'maximal','',false,'title="'.__('Copy this code:').'"').'</p>'.
-'</fieldset>';
+'</div>'.
+'</div>';
 
 echo
Index: plugins/blowupConfig/lib/class.blowup.config.php
===================================================================
--- plugins/blowupConfig/lib/class.blowup.config.php	(revision 1179)
+++ plugins/blowupConfig/lib/class.blowup.config.php	(revision 1436)
@@ -141,4 +141,246 @@
 	}
 
+	public static function cssPath()
+	{
+		global $core;
+		return path::real($core->blog->public_path).'/blowup-css';
+	}
+
+	public static function cssURL()
+	{
+		global $core;
+		return $core->blog->settings->system->public_url.'/blowup-css';
+	}
+
+	public static function canWriteCss($create=false)
+	{
+		global $core;
+
+		$public = path::real($core->blog->public_path);
+		$css = self::cssPath();
+
+		if (!is_dir($public)) {
+			$core->error->add(__('The \'public\' directory does not exist.'));
+			return false;
+		}
+
+		if (!is_dir($css)) {
+			if (!is_writable($public)) {
+				$core->error->add(sprintf(__('The \'%s\' directory cannot be modified.'),'public'));
+				return false;
+			}
+			if ($create) {
+				files::makeDir($css);
+			}
+			return true;
+		}
+
+		if (!is_writable($css)) {
+			$core->error->add(sprintf(__('The \'%s\' directory cannot be modified.'),'public/blowup-css'));
+			return false;
+		}
+
+		return true;
+	}
+
+	public static function createCss($s)
+	{
+		global $core;
+		
+		if ($s === null) {
+			return;
+		}
+
+		$css = array();
+
+		/* Sidebar position
+		---------------------------------------------- */
+		if ($s['sidebar_position'] == 'left') {
+			$css['#wrapper']['background-position'] = '-300px 0';
+			$css['#main']['float'] = 'right';
+			$css['#sidebar']['float'] = 'left';
+		}
+
+		/* Properties
+		---------------------------------------------- */
+		self::prop($css,'body','background-color',$s['body_bg_c']);
+
+		self::prop($css,'body','color',$s['body_txt_c']);
+		self::prop($css,'.post-tags li a:link, .post-tags li a:visited, .post-info-co a:link, .post-info-co a:visited','color',$s['body_txt_c']);
+		self::prop($css,'#page','font-size',$s['body_txt_s']);
+		self::prop($css,'body','font-family',self::fontDef($s['body_txt_f']));
+
+		self::prop($css,'.post-content, .post-excerpt, #comments dd, #pings dd, dd.comment-preview','line-height',$s['body_line_height']);
+
+		if (!$s['blog_title_hide'])
+		{
+			self::prop($css,'#top h1 a','color',$s['blog_title_c']);
+			self::prop($css,'#top h1','font-size',$s['blog_title_s']);
+			self::prop($css,'#top h1','font-family',self::fontDef($s['blog_title_f']));
+
+			if ($s['blog_title_a'] == 'right' || $s['blog_title_a'] == 'left') {
+				$css['#top h1'][$s['blog_title_a']] = '0px';
+				$css['#top h1']['width'] = 'auto';
+			}
+
+			if ($s['blog_title_p'])
+			{
+				$_p = explode(':',$s['blog_title_p']);
+				$css['#top h1']['top'] = $_p[1].'px';
+				if ($s['blog_title_a'] != 'center') {
+					$_a = $s['blog_title_a'] == 'right' ? 'right' : 'left';
+					$css['#top h1'][$_a] = $_p[0].'px';
+				}
+			}
+		}
+		else
+		{
+			self::prop($css,'#top h1 span','text-indent','-5000px');
+			self::prop($css,'#top h1','top','0px');
+			$css['#top h1 a'] = array(
+				'display' => 'block',
+				'height' => $s['top_height'] ? ($s['top_height']-10).'px' : '120px',
+				'width' => '800px'
+			);
+		}
+		self::prop($css,'#top','height',$s['top_height']);
+
+		self::prop($css,'.day-date','color',$s['date_title_c']);
+		self::prop($css,'.day-date','font-family',self::fontDef($s['date_title_f']));
+		self::prop($css,'.day-date','font-size',$s['date_title_s']);
+
+		self::prop($css,'a','color',$s['body_link_c']);
+		self::prop($css,'a:visited','color',$s['body_link_v_c']);
+		self::prop($css,'a:hover, a:focus, a:active','color',$s['body_link_f_c']);
+
+		self::prop($css,'#comment-form input, #comment-form textarea','color',$s['body_link_c']);
+		self::prop($css,'#comment-form input.preview','color',$s['body_link_c']);
+		self::prop($css,'#comment-form input.preview:hover','background',$s['body_link_f_c']);
+		self::prop($css,'#comment-form input.preview:hover','border-color',$s['body_link_f_c']);
+		self::prop($css,'#comment-form input.submit','color',$s['body_link_c']);
+		self::prop($css,'#comment-form input.submit:hover','background',$s['body_link_f_c']);
+		self::prop($css,'#comment-form input.submit:hover','border-color',$s['body_link_f_c']);
+
+		self::prop($css,'#sidebar','font-family',self::fontDef($s['sidebar_text_f']));
+		self::prop($css,'#sidebar','font-size',$s['sidebar_text_s']);
+		self::prop($css,'#sidebar','color',$s['sidebar_text_c']);
+
+		self::prop($css,'#sidebar h2','font-family',self::fontDef($s['sidebar_title_f']));
+		self::prop($css,'#sidebar h2','font-size',$s['sidebar_title_s']);
+		self::prop($css,'#sidebar h2','color',$s['sidebar_title_c']);
+
+		self::prop($css,'#sidebar h3','font-family',self::fontDef($s['sidebar_title2_f']));
+		self::prop($css,'#sidebar h3','font-size',$s['sidebar_title2_s']);
+		self::prop($css,'#sidebar h3','color',$s['sidebar_title2_c']);
+
+		self::prop($css,'#sidebar ul','border-top-color',$s['sidebar_line_c']);
+		self::prop($css,'#sidebar li','border-bottom-color',$s['sidebar_line_c']);
+		self::prop($css,'#topnav ul','border-bottom-color',$s['sidebar_line_c']);
+
+		self::prop($css,'#sidebar li a','color',$s['sidebar_link_c']);
+		self::prop($css,'#sidebar li a:visited','color',$s['sidebar_link_v_c']);
+		self::prop($css,'#sidebar li a:hover, #sidebar li a:focus, #sidebar li a:active','color',$s['sidebar_link_f_c']);
+		self::prop($css,'#search input','color',$s['sidebar_link_c']);
+		self::prop($css,'#search .submit','color',$s['sidebar_link_c']);
+		self::prop($css,'#search .submit:hover','background',$s['sidebar_link_f_c']);
+		self::prop($css,'#search .submit:hover','border-color',$s['sidebar_link_f_c']);
+
+		self::prop($css,'.post-title','color',$s['post_title_c']);
+		self::prop($css,'.post-title a, .post-title a:visited','color',$s['post_title_c']);
+		self::prop($css,'.post-title','font-family',self::fontDef($s['post_title_f']));
+		self::prop($css,'.post-title','font-size',$s['post_title_s']);
+
+		self::prop($css,'#comments dd','background-color',$s['post_comment_bg_c']);
+		self::prop($css,'#comments dd','color',$s['post_comment_c']);
+		self::prop($css,'#comments dd.me','background-color',$s['post_commentmy_bg_c']);
+		self::prop($css,'#comments dd.me','color',$s['post_commentmy_c']);
+
+		self::prop($css,'#prelude, #prelude a','color',$s['prelude_c']);
+
+		self::prop($css,'#footer p','background-color',$s['footer_bg_c']);
+		self::prop($css,'#footer p','color',$s['footer_c']);
+		self::prop($css,'#footer p','font-size',$s['footer_s']);
+		self::prop($css,'#footer p','font-family',self::fontDef($s['footer_f']));
+		self::prop($css,'#footer p a','color',$s['footer_l_c']);
+
+		/* Images
+		------------------------------------------------------ */
+		self::backgroundImg($css,'body',$s['body_bg_c'],'body-bg.png');
+		self::backgroundImg($css,'body',$s['body_bg_g'] != 'light','body-bg.png');
+		self::backgroundImg($css,'body',$s['prelude_c'],'body-bg.png');
+		self::backgroundImg($css,'#top',$s['body_bg_c'],'page-t.png');
+		self::backgroundImg($css,'#top',$s['body_bg_g'] != 'light','page-t.png');
+		self::backgroundImg($css,'#top',$s['uploaded'] || $s['top_image'],'page-t.png');
+		self::backgroundImg($css,'#footer',$s['body_bg_c'],'page-b.png');
+		self::backgroundImg($css,'#comments dt',$s['post_comment_bg_c'],'comment-t.png');
+		self::backgroundImg($css,'#comments dd',$s['post_comment_bg_c'],'comment-b.png');
+		self::backgroundImg($css,'#comments dt.me',$s['post_commentmy_bg_c'],'commentmy-t.png');
+		self::backgroundImg($css,'#comments dd.me',$s['post_commentmy_bg_c'],'commentmy-b.png');
+
+		$res = '';
+		foreach ($css as $selector => $values) {
+			$res .= $selector." {\n";
+			foreach ($values as $k => $v) {
+				$res .= $k.':'.$v.";\n";
+			}
+			$res .= "}\n";
+		}
+
+		$res .= $s['extra_css'];
+
+		if (!self::canWriteCss(true)) {
+			throw new Exception(__('Unable to create css file.'));
+		}
+
+		# erase old css file
+		self::dropCss($core->blog->settings->system->theme);
+
+		# create new css file into public blowup-css subdirectory
+		self::writeCss($core->blog->settings->system->theme, $res);
+
+		return $res;
+	}
+
+	protected static function prop(&$css,$selector,$prop,$value)
+	{
+		if ($value) {
+			$css[$selector][$prop] = $value;
+		}
+	}
+
+	protected static function backgroundImg(&$css,$selector,$value,$image)
+	{
+		$file = self::imagesPath().'/'.$image;
+		if ($value && file_exists($file)){
+			$css[$selector]['background-image'] = 'url('.self::imagesURL().'/'.$image.')';
+		}
+	}
+
+	private static function writeCss($theme,$css)
+	{
+		file_put_contents(self::cssPath().'/'.$theme.'.css', $css);
+	}
+	
+	public static function dropCss($theme)
+	{
+		$file = path::real(self::cssPath().'/'.$theme.'.css');
+		if (is_writable(dirname($file))) {
+			@unlink($file);
+		}
+	}
+
+	public static function publicCssUrlHelper()
+	{
+		$theme = $GLOBALS['core']->blog->settings->system->theme;
+		$url = blowupConfig::cssURL();
+		$path = blowupConfig::cssPath();
+
+		if (file_exists($path.'/'.$theme.'.css')) {
+			return $url.'/'.$theme.'.css';
+		}
+
+		return null;
+	}
+
 	public static function imagesPath()
 	{
Index: plugins/daInstaller/_define.php
===================================================================
--- plugins/daInstaller/_define.php	(revision 1046)
+++ plugins/daInstaller/_define.php	(revision 1568)
@@ -10,5 +10,5 @@
 $this->registerModule(
 	'daInstaller',
-	'Install and update your extensions live from DotAddict.org',
+	'Install and update your plugins live from DotAddict.org',
 	'Tomtom / DotAddict.org',
 	'1.0.3',
Index: plugins/daInstaller/inc/lib.da.installer.ui.php
===================================================================
--- plugins/daInstaller/inc/lib.da.installer.ui.php	(revision 1046)
+++ plugins/daInstaller/inc/lib.da.installer.ui.php	(revision 1568)
@@ -34,5 +34,5 @@
 		}
 		else {
-			$msg_no_entry = __('No extension');
+			$msg_no_entry = __('No plugins');
 			$msg_th_label = __('Plugins');
 			$lineMethod   = 'pluginLine';
@@ -64,5 +64,5 @@
 				'</table>';
 			
-			echo '<p>'.__('Page(s)').' : '.$pager->getLinks().'</p>';
+			echo '<p class="pagination">'.__('Page(s)').' : '.$pager->getLinks().'</p>';
 			$blocks = explode('%s',$html_block);
 			echo $blocks[0];
@@ -81,5 +81,5 @@
 			}
 			echo $blocks[1];
-			echo '<p>'.__('Page(s)').' : '.$pager->getLinks().'</p>';
+			echo '<p class="pagination">'.__('Page(s)').' : '.$pager->getLinks().'</p>';
 		}
 	}
